]> git.wh0rd.org - home.git/blob - .bin/r
r: default to current branch (useful for initial repo creation)
[home.git] / .bin / r
1 #!/bin/bash
2 g() { git "$@"; }
3 err() { printf '%b\n' "$*" 1>&2; exit 1; }
4 vr() { echo "$@"; "$@"; }
5
6 case $1 in
7 ""|-*) ;;
8 l)
9 cmd=list
10 shift
11 ;;
12 s)
13 cmd=sync
14 shift
15 ;;
16 *)
17 cmd=$1
18 shift
19 acmd=$(git config --get "alias.${cmd}" | sed 's: -.*::')
20 ;;
21 esac
22
23 mj_init() {
24 pipe=$(mktemp)
25 rm -f "${pipe}"
26 mkfifo "${pipe}"
27 exec {ctlfd}<>"${pipe}"
28 rm -f "${pipe}"
29 jobs=0
30 jobs_max=${1:-$(getconf _NPROCESSORS_ONLN)}
31 }
32 _mj_child() { echo ${BASHPID} $? >&${ctlfd} ; }
33 mj_child() {
34 (
35 "$@"
36 _mj_child
37 ) &
38 mj_post_child
39 }
40 mj_post_child() {
41 : $(( ++jobs ))
42 if [[ ${jobs} -eq ${jobs_max} ]] ; then
43 read -r -u ${ctlfd} pid ret
44 : $(( --jobs ))
45 fi
46 }
47 mj_finish() {
48 wait
49 }
50
51 repo_root() {
52 local root=${PWD}
53 while [[ ! -d ${root}/.repo && ${root} != "/" ]] ; do
54 root=${root%/*}
55 done
56 echo "${root}"
57 }
58
59 case ${acmd:-${cmd}} in
60 rebase)
61 if [[ $1 == "all" ]] ; then
62 shift
63 if [[ $# -eq 0 ]] ; then
64 eval $(bash-colors --env | sed 's:^:export :')
65 root=$(repo_root)
66 mj_init
67 while read -a line ; do
68 dir=${line[0]}
69 proj=${line[2]}
70 cd "${root}/${dir}"
71 (
72 out=$(env _proj=${proj} r rb all . 2>&1)
73 if [[ -n ${out} ]] ; then
74 while read line ; do
75 if [[ ${line} == "# "* ]] ; then
76 line="${line#[#] }"
77 printf '%s### %s%-40s%s: %s\n' \
78 "${BRACKET}" "${GOOD}" "${line%%:*}" "${NORMAL}" "${line#*:}"
79 else
80 echo "${line}"
81 fi
82 done < <(echo "${out}")
83 fi
84 _mj_child
85 ) &
86 mj_post_child
87 done < <(r l)
88 mj_finish
89 exit 0
90 #exec r forall -p -c 'r rb all .' </dev/null
91 fi
92
93 branches=$(g b | awk '
94 {
95 if ($0 ~ "^[*] *[(]no branch[)]") {
96 next
97 } else if ($0 ~ "^[*] *[(]detached from ") {
98 next
99 } else if ($1 == "*") {
100 b = $2
101 } else {
102 list = list $1 " "
103 }
104 }
105 END { print list b }')
106 [[ -z ${branches} ]] && exit 0
107
108 [[ -z ${GOOD} ]] && eval $(bash-colors --env)
109 #echo "${GOOD}### ${PWD}${NORMAL}"
110 # Skip if rebase is in progress.
111 if [[ -e .git/rebase-merge/interactive ]] ; then
112 echo -e "# ${_proj}: ${WARN}skipping due to active rebase${NORMAL}"
113 exit 1
114 fi
115 for b in ${branches} ; do
116 #echo " ${HILITE}### $b${NORMAL}"
117 g co -q $b || exit 1
118 if ! r rb -q "$@" ; then
119 g rb-a
120 fi
121 done
122 exit 0
123 fi
124 ;;
125 clean)
126 root=$(repo_root)
127 cd "${root}" || exit 1
128 mj_init
129 while read -a line ; do
130 dir=${line[0]}
131 proj=${line[2]}
132 cd "${root}/${dir}"
133 (
134 out=$(g clean "$@" 2>&1)
135 if [[ -n ${out} ]] ; then
136 echo "### ${proj}"
137 echo "${out}"
138 fi
139 _mj_child
140 ) &
141 mj_post_child
142 done < <(r l)
143 mj_finish
144 exit
145 ;;
146 sb-push)
147 sync_branch="v"
148
149 root=$(repo_root)
150 cd "${root}" || exit 1
151
152 if [[ ! -e .repo/sandbox-url ]] ; then
153 err "Please configure remote url base in ${root}/.repo/sandbox-url"
154 fi
155 remote=$(<.repo/sandbox-url) || exit 1
156
157 echo "pushing projects from ${root}"
158
159 # ssh servers do not like it when you hammer them :)
160 # Received disconnect from 74.125.248.80: 7: Too many concurrent connections
161 # fatal: The remote end hung up unexpectedly
162 mj_init 16
163
164 rlist=$(r l)
165 tcnt=$(echo "${rlist}" | wc -l)
166 cnt=1
167 while read line ; do
168 line=( ${line} )
169 path=${line[0]}
170 export GIT_DIR=${path}/.git
171 proj=${line[2]}
172 printf '### (%*i/%i %3i%%) %s\n' \
173 ${#tcnt} $((cnt++)) ${tcnt} $(( cnt * 100 / tcnt )) ${proj}
174 src="${sync_branch}"
175 g l -1 ${src} >& /dev/null || src=
176 mj_child g push --force ${remote}/${proj} ${src}:refs/sandbox/${USER}/${sync_branch} >/dev/null
177 done < <(echo "${rlist}")
178 mj_finish
179
180 exit 0
181 ;;
182 g-push)
183 # For the times when repo is being stupid, push directly to gerrit myself.
184 if ! branch=$(g symbolic-ref -q HEAD) ; then
185 err "could not figure out active branch"
186 fi
187 branch=${branch#refs/heads/}
188 if ! remote_branch=$(g cfg --get "branch.${branch}.merge") ; then
189 echo "could not figure out remote branch; using ${branch}"
190 remote_branch=${branch}
191 fi
192 if ! remote=$(g cfg --get "branch.${branch}.remote") ; then
193 for remote in cros-internal cros origin ; do
194 g cfg --get "remote.${remote}.url" >/dev/null && break
195 done
196 fi
197 remote_branch=${remote_branch#refs/heads/}
198
199 git_args=()
200 reviewers=""
201 while [[ $# -gt 0 ]] ; do
202 case $1 in
203 --re)
204 reviewers=$2
205 shift
206 ;;
207 -n|--dry-run)
208 git_args+=( $1 )
209 ;;
210 *)
211 err "unknown option: $1"
212 ;;
213 esac
214 shift
215 done
216
217 if [[ -n ${reviewers} ]] ; then
218 reviewers=( ${reviewers//,/ } )
219 git_args+=( "--receive-pack=git receive-pack ${reviewers[*]/#/--reviewer=}" )
220 fi
221
222 vr git push "${git_args[@]}" ${remote} ${branch}:refs/for/${remote_branch} && exit
223 err "could not figure out remote to push to"
224 ;;
225 sync)
226 set -- -j16 -c "$@"
227 ;;
228 upload)
229 args=()
230 while [[ $# -gt 0 ]] ; do
231 case $1 in
232 --re)
233 if [[ $2 == *"OWNERS" ]] ; then
234 owners=$(awk -F'@' '{list = list "," $1} END {print substr(list, 2)}' "$2")
235 if [[ -z ${owners} ]] ; then
236 err "cannot find OWNERS list"
237 else
238 echo "Auto setting reviewers to: ${owners}"
239 fi
240 args+=( --re "${owners}" )
241 shift 2
242 continue
243 fi
244 ;;
245 esac
246 args+=( "$1" )
247 shift
248 done
249 set -- "${args[@]}"
250 ;;
251 email)
252 email=${1:-${USER}@chromium.org}
253 cmd='forall'
254 set -- -c "git cfg user.email ${email}"
255 ;;
256 esac
257
258 exec repo ${acmd:-${cmd}} "$@"